Browse code

packaging-ubuntu, issue #30: streamline building and uploading to PPA

Daniel Mizyrycki authored on 2013/04/16 10:01:54
Showing 10 changed files
... ...
@@ -1,73 +1,57 @@
1
-PKG_NAME=lxc-docker
2
-PKG_ARCH=amd64
3
-PKG_VERSION=1
4
-ROOT_PATH:=$(PWD)
5
-BUILD_PATH=build	# Do not change, decided by dpkg-buildpackage
6
-BUILD_SRC=build_src
7
-GITHUB_PATH=src/github.com/dotcloud/docker
8
-INSDIR=usr/bin
9
-SOURCE_PACKAGE=$(PKG_NAME)_$(PKG_VERSION).orig.tar.gz
10
-DEB_PACKAGE=$(PKG_NAME)_$(PKG_VERSION)_$(PKG_ARCH).deb
11
-EXTRA_GO_PKG=./auth
12
-
13
-TMPDIR=$(shell mktemp -d -t XXXXXX)
1
+# Ubuntu package Makefile
2
+#
3
+# Dependencies:  debhelper autotools-dev devscripts golang
4
+# Notes:
5
+# Use 'make ubuntu' to create the ubuntu package
6
+# GPG_KEY environment variable needs to contain a GPG private key for package to be signed
7
+# and uploaded to docker PPA.
8
+# If GPG_KEY is not defined, make ubuntu will create docker package and exit with
9
+# status code 2
14 10
 
11
+PKG_NAME=lxc-docker
12
+VERSION=$(shell head -1 changelog | sed 's/^.\+(\(.\+\)..).\+$$/\1/')
13
+GITHUB_PATH=github.com/dotcloud/docker
14
+DOCKER_VERSION=${PKG_NAME}_${VERSION}
15
+DOCKER_FVERSION=${PKG_NAME}_$(shell head -1 changelog | sed 's/^.\+(\(.\+\)).\+$$/\1/')
16
+BUILD_SRC=${CURDIR}/../../build_src
15 17
 
16
-# Build a debian source package
17
-all: clean build_in_deb
18
-
19
-build_in_deb:
20
-	echo "GOPATH = " $(ROOT_PATH)
21
-	mkdir bin
22
-	cd $(GITHUB_PATH)/docker; GOPATH=$(ROOT_PATH) go build -o $(ROOT_PATH)/bin/docker
18
+all:
19
+	# Compile docker. Used by dpkg-buildpackage.
20
+	cd src/${GITHUB_PATH}/docker; GOPATH=${CURDIR} go build
23 21
 
24
-# DESTDIR provided by Debian packaging
25 22
 install:
26
-	# Call this from a go environment (as packaged for deb source package)
27
-	mkdir -p $(DESTDIR)/$(INSDIR)
28
-	mkdir -p $(DESTDIR)/etc/init
29
-	install -m 0755 bin/docker $(DESTDIR)/$(INSDIR)
30
-	install -o root -m 0755 etc/docker.upstart $(DESTDIR)/etc/init/docker.conf
31
-
32
-$(BUILD_SRC): clean
33
-	# Copy ourselves into $BUILD_SRC to comply with unusual golang constraints
34
-	tar --exclude=*.tar.gz --exclude=checkout.tgz -f checkout.tgz -cz *
35
-	mkdir -p $(BUILD_SRC)/$(GITHUB_PATH)
36
-	tar -f checkout.tgz -C $(BUILD_SRC)/$(GITHUB_PATH) -xz
37
-	cd $(BUILD_SRC)/$(GITHUB_PATH)/docker; GOPATH=$(ROOT_PATH)/$(BUILD_SRC) go get -d
38
-	for d in `find $(BUILD_SRC) -name '.git*'`; do rm -rf $$d; done
39
-	# Populate source build with debian stuff
40
-	cp -R -L ./deb/* $(BUILD_SRC)
41
-
42
-$(SOURCE_PACKAGE): $(BUILD_SRC)
43
-	rm -f $(SOURCE_PACKAGE)
44
-	# Create the debian source package
45
-	tar -f $(SOURCE_PACKAGE) -C ${ROOT_PATH}/${BUILD_SRC} -cz .
46
-
47
-# Build deb package fetching go dependencies and cleaning up git repositories
48
-deb: $(DEB_PACKAGE)
49
-
50
-$(DEB_PACKAGE): $(SOURCE_PACKAGE)
51
-	# dpkg-buildpackage looks for source package tarball in ../
52
-	cd $(BUILD_SRC); dpkg-buildpackage
53
-	rm -rf $(BUILD_PATH) debian/$(PKG_NAME)* debian/files
54
-
55
-debsrc: $(SOURCE_PACKAGE)
56
-
57
-# Build local sources
58
-#$(PKG_NAME): build_local
59
-
60
-build_local:
61
-	-@mkdir -p bin
62
-	cd docker && go build -o ../bin/docker
63
-
64
-gotest:
65
-	@echo "\033[36m[Testing]\033[00m docker..."
66
-	@sudo -E GOPATH=$(ROOT_PATH)/$(BUILD_SRC) go test -v . $(EXTRA_GO_PKG) && \
67
-		echo -n "\033[32m[OK]\033[00m" || \
68
-		echo -n "\033[31m[FAIL]\033[00m"; \
69
-		echo " docker"
70
-	@sudo rm -rf /tmp/docker-*
71
-
72
-clean:
73
-	rm -rf $(BUILD_PATH) debian/$(PKG_NAME)* debian/files $(BUILD_SRC) checkout.tgz bin
23
+	# Used by dpkg-buildpackage
24
+	mkdir -p ${DESTDIR}/usr/bin
25
+	mkdir -p ${DESTDIR}/etc/init
26
+	install -m 0755 src/${GITHUB_PATH}/docker/docker ${DESTDIR}/usr/bin
27
+	install -o root -m 0755 debian/docker.upstart ${DESTDIR}/etc/init/docker.conf
28
+
29
+ubuntu:
30
+	# This Makefile will compile the github master branch of dotcloud/docker
31
+	# Retrieve docker project and its go structure from internet
32
+	rm -rf ${BUILD_SRC}
33
+	GOPATH=${BUILD_SRC} go get ${GITHUB_PATH}
34
+	# Add debianization
35
+	mkdir ${BUILD_SRC}/debian
36
+	cp Makefile ${BUILD_SRC}
37
+	cp -r * ${BUILD_SRC}/debian
38
+	cp ../../README.md ${BUILD_SRC}
39
+	# Cleanup
40
+	for d in `find ${BUILD_SRC} -name '.git*'`; do rm -rf $$d; done
41
+	rm -rf ${BUILD_SRC}/../${DOCKER_VERSION}.orig.tar.gz
42
+	rm -rf ${BUILD_SRC}/pkg
43
+	# Create docker debian files
44
+	cd ${BUILD_SRC}; tar czf ../${DOCKER_VERSION}.orig.tar.gz .
45
+	cd ${BUILD_SRC}; dpkg-buildpackage -us -uc
46
+	rm -rf ${BUILD_SRC}
47
+	# Sign package and upload it to PPA if GPG_KEY environment variable
48
+	# holds a private GPG KEY
49
+	if /usr/bin/test "$${GPG_KEY}" == ""; then exit 2; fi
50
+	mkdir ${BUILD_SRC}
51
+	# Import gpg signing key
52
+	echo "$${GPG_KEY}" | gpg --allow-secret-key-import --import
53
+	# Sign the package
54
+	cd ${BUILD_SRC}; dpkg-source -x ${BUILD_SRC}/../${DOCKER_FVERSION}.dsc
55
+	cd ${BUILD_SRC}/${PKG_NAME}-${VERSION}; debuild -S -sa
56
+	cd ${BUILD_SRC};dput ppa:dotcloud/lxc-docker ${DOCKER_FVERSION}_source.changes
57
+	rm -rf ${BUILD_SRC}
74 58
new file mode 100644
... ...
@@ -0,0 +1,37 @@
0
+Docker on Ubuntu
1
+================
2
+
3
+The easiest way to get docker up and running natively on Ubuntu is installing
4
+it from its official PPA::
5
+
6
+  sudo sh -c "echo 'deb http://ppa.launchpad.net/dotcloud/lxc-docker/ubuntu precise main' >>/etc/apt/sources.list"
7
+  sudo apt-get update
8
+  sudo apt-get install lxc-docker
9
+
10
+
11
+Building docker package
12
+~~~~~~~~~~~~~~~~~~~~~~~
13
+
14
+The building process is shared by both, developers and maintainers. If you are
15
+a developer, the Makefile will stop with exit status 2 right before signing
16
+the built packages.
17
+
18
+Assuming you are working on an Ubuntu 12.04 TLS system ::
19
+
20
+  # Download a fresh copy of the docker project
21
+  git clone https://github.com/dotcloud/docker.git
22
+  cd docker
23
+
24
+  # Get building dependencies
25
+  sudo apt-get update; sudo apt-get install -y debhelper autotools-dev devscripts golang
26
+
27
+  # Make the ubuntu package
28
+  (cd packaging/ubuntu; make ubuntu)
29
+
30
+
31
+Install docker built package
32
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
33
+
34
+::
35
+
36
+  sudo dpkg -i lxc-docker_*_amd64.deb; sudo apt-get install -f -y
0 37
new file mode 100644
... ...
@@ -0,0 +1,12 @@
0
+BUILDBOT_IP = '192.168.33.32'
1
+
2
+Vagrant::Config.run do |config|
3
+  config.vm.box = 'quantal64_3.5.0-25'
4
+  config.vm.box_url = 'http://get.docker.io/vbox/ubuntu/12.10/quantal64_3.5.0-25.box'
5
+  config.vm.share_folder 'v-data', '/data/docker', "#{File.dirname(__FILE__)}/../.."
6
+  config.vm.network :hostonly,BUILDBOT_IP
7
+
8
+  # Install ubuntu packaging dependencies and create ubuntu packages
9
+  config.vm.provision :shell, :inline => 'export DEBIAN_FRONTEND=noninteractive; apt-get -qq update; apt-get install -qq -y debhelper autotools-dev devscripts golang'
10
+  config.vm.provision :shell, :inline => "export GPG_KEY='#{ENV['GPG_KEY']}'; cd /data/docker/packaging/ubuntu; make ubuntu"
11
+end
... ...
@@ -1,4 +1,21 @@
1
-lxc-docker (1) precise; urgency=low
1
+lxc-docker (0.1.4.1-1) precise; urgency=low
2
+
3
+  Improvements [+], Updates [*], Bug fixes [-]:
4
+  * Test PPA
5
+
6
+ -- dotCloud <ops@dotcloud.com>  Fri, 15 Apr 2013 12:14:50 -0700
7
+
8
+
9
+lxc-docker (0.1.4-1) precise; urgency=low
10
+
11
+  Improvements [+], Updates [*], Bug fixes [-]:
12
+  * Changed default bridge interface do 'docker0'
13
+  - Fix a race condition when running the port allocator
14
+
15
+ -- dotCloud <ops@dotcloud.com>  Fri, 12 Apr 2013 12:20:06 -0700
16
+
17
+
18
+lxc-docker (0.1.0-1) unstable; urgency=low
2 19
 
3 20
   * Initial release
4 21
 
... ...
@@ -1,19 +1,19 @@
1 1
 Source: lxc-docker
2 2
 Section: misc
3 3
 Priority: extra
4
-Homepage: http://docker.io
5 4
 Maintainer: Daniel Mizyrycki <daniel@dotcloud.com>
6
-Build-Depends: debhelper (>= 8.0.0), pkg-config, git, golang, libsqlite3-dev
7
-Vcs-Git: http://github.com/dotcloud/docker.git
5
+Build-Depends: debhelper,autotools-dev,devscripts,golang
8 6
 Standards-Version: 3.9.3
7
+Homepage: http://github.com/dotcloud/docker
9 8
 
10 9
 Package: lxc-docker
11
-Architecture: amd64
12
-Depends: ${shlibs:Depends}, ${misc:Depends}, lxc, wget, bsdtar, curl, sqlite3
10
+Architecture: linux-any
11
+Depends: ${misc:Depends},${shlibs:Depends},lxc,bsdtar
13 12
 Conflicts: docker
14
-Description: A process manager with superpowers
15
-    It encapsulates heterogeneous payloads in Standard Containers, and runs
16
-    them on any server with strong guarantees of isolation and repeatability.
17
-    Is is a great building block for automating distributed systems:
18
-    large-scale web deployments, database clusters, continuous deployment
19
-    systems, private PaaS, service-oriented architectures, etc.
13
+Description: lxc-docker is a Linux container runtime
14
+ Docker complements LXC with a high-level API which operates at the process
15
+ level. It runs unix processes with strong guarantees of isolation and
16
+ repeatability across servers.
17
+ Docker is a great building block for automating distributed systems:
18
+ large-scale web deployments, database clusters, continuous deployment systems,
19
+ private PaaS, service-oriented architectures, etc.
... ...
@@ -1,209 +1,237 @@
1
-Format: http://dep.debian.net/deps/dep5
1
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
2 2
 Upstream-Name: docker
3
-Source: https://github.com/dotcloud/docker
3
+Upstream-Contact: DotCloud Inc <opensource@dotcloud.com>
4
+Source: http://github.com/dotcloud/docker
4 5
 
5 6
 Files: *
6
-Copyright: 2012 DotCloud Inc (opensource@dotcloud.com)
7
-License: Apache License Version 2.0
8
-
9
-                                Apache License
10
-                           Version 2.0, January 2004
11
-                        http://www.apache.org/licenses/
12
-
13
-   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
14
-
15
-   1. Definitions.
16
-
17
-      "License" shall mean the terms and conditions for use, reproduction,
18
-      and distribution as defined by Sections 1 through 9 of this document.
19
-
20
-      "Licensor" shall mean the copyright owner or entity authorized by
21
-      the copyright owner that is granting the License.
22
-
23
-      "Legal Entity" shall mean the union of the acting entity and all
24
-      other entities that control, are controlled by, or are under common
25
-      control with that entity. For the purposes of this definition,
26
-      "control" means (i) the power, direct or indirect, to cause the
27
-      direction or management of such entity, whether by contract or
28
-      otherwise, or (ii) ownership of fifty percent (50%) or more of the
29
-      outstanding shares, or (iii) beneficial ownership of such entity.
30
-
31
-      "You" (or "Your") shall mean an individual or Legal Entity
32
-      exercising permissions granted by this License.
33
-
34
-      "Source" form shall mean the preferred form for making modifications,
35
-      including but not limited to software source code, documentation
36
-      source, and configuration files.
37
-
38
-      "Object" form shall mean any form resulting from mechanical
39
-      transformation or translation of a Source form, including but
40
-      not limited to compiled object code, generated documentation,
41
-      and conversions to other media types.
42
-
43
-      "Work" shall mean the work of authorship, whether in Source or
44
-      Object form, made available under the License, as indicated by a
45
-      copyright notice that is included in or attached to the work
46
-      (an example is provided in the Appendix below).
47
-
48
-      "Derivative Works" shall mean any work, whether in Source or Object
49
-      form, that is based on (or derived from) the Work and for which the
50
-      editorial revisions, annotations, elaborations, or other modifications
51
-      represent, as a whole, an original work of authorship. For the purposes
52
-      of this License, Derivative Works shall not include works that remain
53
-      separable from, or merely link (or bind by name) to the interfaces of,
54
-      the Work and Derivative Works thereof.
55
-
56
-      "Contribution" shall mean any work of authorship, including
57
-      the original version of the Work and any modifications or additions
58
-      to that Work or Derivative Works thereof, that is intentionally
59
-      submitted to Licensor for inclusion in the Work by the copyright owner
60
-      or by an individual or Legal Entity authorized to submit on behalf of
61
-      the copyright owner. For the purposes of this definition, "submitted"
62
-      means any form of electronic, verbal, or written communication sent
63
-      to the Licensor or its representatives, including but not limited to
64
-      communication on electronic mailing lists, source code control systems,
65
-      and issue tracking systems that are managed by, or on behalf of, the
66
-      Licensor for the purpose of discussing and improving the Work, but
67
-      excluding communication that is conspicuously marked or otherwise
68
-      designated in writing by the copyright owner as "Not a Contribution."
69
-
70
-      "Contributor" shall mean Licensor and any individual or Legal Entity
71
-      on behalf of whom a Contribution has been received by Licensor and
72
-      subsequently incorporated within the Work.
73
-
74
-   2. Grant of Copyright License. Subject to the terms and conditions of
75
-      this License, each Contributor hereby grants to You a perpetual,
76
-      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
77
-      copyright license to reproduce, prepare Derivative Works of,
78
-      publicly display, publicly perform, sublicense, and distribute the
79
-      Work and such Derivative Works in Source or Object form.
80
-
81
-   3. Grant of Patent License. Subject to the terms and conditions of
82
-      this License, each Contributor hereby grants to You a perpetual,
83
-      worldwide, non-exclusive, no-charge, royalty-free, irrevocable
84
-      (except as stated in this section) patent license to make, have made,
85
-      use, offer to sell, sell, import, and otherwise transfer the Work,
86
-      where such license applies only to those patent claims licensable
87
-      by such Contributor that are necessarily infringed by their
88
-      Contribution(s) alone or by combination of their Contribution(s)
89
-      with the Work to which such Contribution(s) was submitted. If You
90
-      institute patent litigation against any entity (including a
91
-      cross-claim or counterclaim in a lawsuit) alleging that the Work
92
-      or a Contribution incorporated within the Work constitutes direct
93
-      or contributory patent infringement, then any patent licenses
94
-      granted to You under this License for that Work shall terminate
95
-      as of the date such litigation is filed.
96
-
97
-   4. Redistribution. You may reproduce and distribute copies of the
98
-      Work or Derivative Works thereof in any medium, with or without
99
-      modifications, and in Source or Object form, provided that You
100
-      meet the following conditions:
101
-
102
-      (a) You must give any other recipients of the Work or
103
-          Derivative Works a copy of this License; and
104
-
105
-      (b) You must cause any modified files to carry prominent notices
106
-          stating that You changed the files; and
107
-
108
-      (c) You must retain, in the Source form of any Derivative Works
109
-          that You distribute, all copyright, patent, trademark, and
110
-          attribution notices from the Source form of the Work,
111
-          excluding those notices that do not pertain to any part of
112
-          the Derivative Works; and
113
-
114
-      (d) If the Work includes a "NOTICE" text file as part of its
115
-          distribution, then any Derivative Works that You distribute must
116
-          include a readable copy of the attribution notices contained
117
-          within such NOTICE file, excluding those notices that do not
118
-          pertain to any part of the Derivative Works, in at least one
119
-          of the following places: within a NOTICE text file distributed
120
-          as part of the Derivative Works; within the Source form or
121
-          documentation, if provided along with the Derivative Works; or,
122
-          within a display generated by the Derivative Works, if and
123
-          wherever such third-party notices normally appear. The contents
124
-          of the NOTICE file are for informational purposes only and
125
-          do not modify the License. You may add Your own attribution
126
-          notices within Derivative Works that You distribute, alongside
127
-          or as an addendum to the NOTICE text from the Work, provided
128
-          that such additional attribution notices cannot be construed
129
-          as modifying the License.
130
-
131
-      You may add Your own copyright statement to Your modifications and
132
-      may provide additional or different license terms and conditions
133
-      for use, reproduction, or distribution of Your modifications, or
134
-      for any such Derivative Works as a whole, provided Your use,
135
-      reproduction, and distribution of the Work otherwise complies with
136
-      the conditions stated in this License.
137
-
138
-   5. Submission of Contributions. Unless You explicitly state otherwise,
139
-      any Contribution intentionally submitted for inclusion in the Work
140
-      by You to the Licensor shall be under the terms and conditions of
141
-      this License, without any additional terms or conditions.
142
-      Notwithstanding the above, nothing herein shall supersede or modify
143
-      the terms of any separate license agreement you may have executed
144
-      with Licensor regarding such Contributions.
145
-
146
-   6. Trademarks. This License does not grant permission to use the trade
147
-      names, trademarks, service marks, or product names of the Licensor,
148
-      except as required for reasonable and customary use in describing the
149
-      origin of the Work and reproducing the content of the NOTICE file.
150
-
151
-   7. Disclaimer of Warranty. Unless required by applicable law or
152
-      agreed to in writing, Licensor provides the Work (and each
153
-      Contributor provides its Contributions) on an "AS IS" BASIS,
154
-      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
155
-      implied, including, without limitation, any warranties or conditions
156
-      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
157
-      PARTICULAR PURPOSE. You are solely responsible for determining the
158
-      appropriateness of using or redistributing the Work and assume any
159
-      risks associated with Your exercise of permissions under this License.
160
-
161
-   8. Limitation of Liability. In no event and under no legal theory,
162
-      whether in tort (including negligence), contract, or otherwise,
163
-      unless required by applicable law (such as deliberate and grossly
164
-      negligent acts) or agreed to in writing, shall any Contributor be
165
-      liable to You for damages, including any direct, indirect, special,
166
-      incidental, or consequential damages of any character arising as a
167
-      result of this License or out of the use or inability to use the
168
-      Work (including but not limited to damages for loss of goodwill,
169
-      work stoppage, computer failure or malfunction, or any and all
170
-      other commercial damages or losses), even if such Contributor
171
-      has been advised of the possibility of such damages.
172
-
173
-   9. Accepting Warranty or Additional Liability. While redistributing
174
-      the Work or Derivative Works thereof, You may choose to offer,
175
-      and charge a fee for, acceptance of support, warranty, indemnity,
176
-      or other liability obligations and/or rights consistent with this
177
-      License. However, in accepting such obligations, You may act only
178
-      on Your own behalf and on Your sole responsibility, not on behalf
179
-      of any other Contributor, and only if You agree to indemnify,
180
-      defend, and hold each Contributor harmless for any liability
181
-      incurred by, or claims asserted against, such Contributor by reason
182
-      of your accepting any such warranty or additional liability.
183
-
184
-   END OF TERMS AND CONDITIONS
185
-
186
-   APPENDIX: How to apply the Apache License to your work.
187
-
188
-      To apply the Apache License to your work, attach the following
189
-      boilerplate notice, with the fields enclosed by brackets "[]"
190
-      replaced with your own identifying information. (Don't include
191
-      the brackets!) The text should be enclosed in the appropriate
192
-      comment syntax for the file format. We also recommend that a
193
-      file or class name and description of purpose be included on the
194
-      same "printed page" as the copyright notice for easier
195
-      identification within third-party archives.
196
-
197
-   Copyright 2012 DotCloud Inc (opensource@dotcloud.com)
198
-
199
-   Licensed under the Apache License, Version 2.0 (the "License");
200
-   you may not use this file except in compliance with the License.
201
-   You may obtain a copy of the License at
202
-
203
-       http://www.apache.org/licenses/LICENSE-2.0
204
-
205
-   Unless required by applicable law or agreed to in writing, software
206
-   distributed under the License is distributed on an "AS IS" BASIS,
207
-   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
208
-   See the License for the specific language governing permissions and
209
-   limitations under the License.
7
+Copyright: 2012, DotCloud Inc <opensource@dotcloud.com>
8
+License: Apache-2.0
9
+ Apache License
10
+ Version 2.0, January 2004
11
+ http://www.apache.org/licenses/
12
+ 
13
+ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION
14
+ 
15
+ 1. Definitions.
16
+ 
17
+ "License" shall mean the terms and conditions for use, reproduction,
18
+ and distribution as defined by Sections 1 through 9 of this document.
19
+ 
20
+ "Licensor" shall mean the copyright owner or entity authorized by
21
+ the copyright owner that is granting the License.
22
+ 
23
+ "Legal Entity" shall mean the union of the acting entity and all
24
+ other entities that control, are controlled by, or are under common
25
+ control with that entity. For the purposes of this definition,
26
+ "control" means (i) the power, direct or indirect, to cause the
27
+ direction or management of such entity, whether by contract or
28
+ otherwise, or (ii) ownership of fifty percent (50%) or more of the
29
+ outstanding shares, or (iii) beneficial ownership of such entity.
30
+ 
31
+ "You" (or "Your") shall mean an individual or Legal Entity
32
+ exercising permissions granted by this License.
33
+ 
34
+ "Source" form shall mean the preferred form for making modifications,
35
+ including but not limited to software source code, documentation
36
+ source, and configuration files.
37
+ 
38
+ "Object" form shall mean any form resulting from mechanical
39
+ transformation or translation of a Source form, including but
40
+ not limited to compiled object code, generated documentation,
41
+ and conversions to other media types.
42
+ 
43
+ "Work" shall mean the work of authorship, whether in Source or
44
+ Object form, made available under the License, as indicated by a
45
+ copyright notice that is included in or attached to the work
46
+ (an example is provided in the Appendix below).
47
+ 
48
+ "Derivative Works" shall mean any work, whether in Source or Object
49
+ form, that is based on (or derived from) the Work and for which the
50
+ editorial revisions, annotations, elaborations, or other modifications
51
+ represent, as a whole, an original work of authorship. For the purposes
52
+ of this License, Derivative Works shall not include works that remain
53
+ separable from, or merely link (or bind by name) to the interfaces of,
54
+ the Work and Derivative Works thereof.
55
+ 
56
+ "Contribution" shall mean any work of authorship, including
57
+ the original version of the Work and any modifications or additions
58
+ to that Work or Derivative Works thereof, that is intentionally
59
+ submitted to Licensor for inclusion in the Work by the copyright owner
60
+ or by an individual or Legal Entity authorized to submit on behalf of
61
+ the copyright owner. For the purposes of this definition, "submitted"
62
+ means any form of electronic, verbal, or written communication sent
63
+ to the Licensor or its representatives, including but not limited to
64
+ communication on electronic mailing lists, source code control systems,
65
+ and issue tracking systems that are managed by, or on behalf of, the
66
+ Licensor for the purpose of discussing and improving the Work, but
67
+ excluding communication that is conspicuously marked or otherwise
68
+ designated in writing by the copyright owner as "Not a Contribution."
69
+ 
70
+ "Contributor" shall mean Licensor and any individual or Legal Entity
71
+ on behalf of whom a Contribution has been received by Licensor and
72
+ subsequently incorporated within the Work.
73
+ 
74
+ 2. Grant of Copyright License. Subject to the terms and conditions of
75
+ this License, each Contributor hereby grants to You a perpetual,
76
+ worldwide, non-exclusive, no-charge, royalty-free, irrevocable
77
+ copyright license to reproduce, prepare Derivative Works of,
78
+ publicly display, publicly perform, sublicense, and distribute the
79
+ Work and such Derivative Works in Source or Object form.
80
+ 
81
+ 3. Grant of Patent License. Subject to the terms and conditions of
82
+ this License, each Contributor hereby grants to You a perpetual,
83
+ worldwide, non-exclusive, no-charge, royalty-free, irrevocable
84
+ (except as stated in this section) patent license to make, have made,
85
+ use, offer to sell, sell, import, and otherwise transfer the Work,
86
+ where such license applies only to those patent claims licensable
87
+ by such Contributor that are necessarily infringed by their
88
+ Contribution(s) alone or by combination of their Contribution(s)
89
+ with the Work to which such Contribution(s) was submitted. If You
90
+ institute patent litigation against any entity (including a
91
+ cross-claim or counterclaim in a lawsuit) alleging that the Work
92
+ or a Contribution incorporated within the Work constitutes direct
93
+ or contributory patent infringement, then any patent licenses
94
+ granted to You under this License for that Work shall terminate
95
+ as of the date such litigation is filed.
96
+ 
97
+ 4. Redistribution. You may reproduce and distribute copies of the
98
+ Work or Derivative Works thereof in any medium, with or without
99
+ modifications, and in Source or Object form, provided that You
100
+ meet the following conditions:
101
+ 
102
+ (a) You must give any other recipients of the Work or
103
+ Derivative Works a copy of this License; and
104
+ 
105
+ (b) You must cause any modified files to carry prominent notices
106
+ stating that You changed the files; and
107
+ 
108
+ (c) You must retain, in the Source form of any Derivative Works
109
+ that You distribute, all copyright, patent, trademark, and
110
+ attribution notices from the Source form of the Work,
111
+ excluding those notices that do not pertain to any part of
112
+ the Derivative Works; and
113
+ 
114
+ (d) If the Work includes a "NOTICE" text file as part of its
115
+ distribution, then any Derivative Works that You distribute must
116
+ include a readable copy of the attribution notices contained
117
+ within such NOTICE file, excluding those notices that do not
118
+ pertain to any part of the Derivative Works, in at least one
119
+ of the following places: within a NOTICE text file distributed
120
+ as part of the Derivative Works; within the Source form or
121
+ documentation, if provided along with the Derivative Works; or,
122
+ within a display generated by the Derivative Works, if and
123
+ wherever such third-party notices normally appear. The contents
124
+ of the NOTICE file are for informational purposes only and
125
+ do not modify the License. You may add Your own attribution
126
+ notices within Derivative Works that You distribute, alongside
127
+ or as an addendum to the NOTICE text from the Work, provided
128
+ that such additional attribution notices cannot be construed
129
+ as modifying the License.
130
+ 
131
+ You may add Your own copyright statement to Your modifications and
132
+ may provide additional or different license terms and conditions
133
+ for use, reproduction, or distribution of Your modifications, or
134
+ for any such Derivative Works as a whole, provided Your use,
135
+ reproduction, and distribution of the Work otherwise complies with
136
+ the conditions stated in this License.
137
+ 
138
+ 5. Submission of Contributions. Unless You explicitly state otherwise,
139
+ any Contribution intentionally submitted for inclusion in the Work
140
+ by You to the Licensor shall be under the terms and conditions of
141
+ this License, without any additional terms or conditions.
142
+ Notwithstanding the above, nothing herein shall supersede or modify
143
+ the terms of any separate license agreement you may have executed
144
+ with Licensor regarding such Contributions.
145
+ 
146
+ 6. Trademarks. This License does not grant permission to use the trade
147
+ names, trademarks, service marks, or product names of the Licensor,
148
+ except as required for reasonable and customary use in describing the
149
+ origin of the Work and reproducing the content of the NOTICE file.
150
+ 
151
+ 7. Disclaimer of Warranty. Unless required by applicable law or
152
+ agreed to in writing, Licensor provides the Work (and each
153
+ Contributor provides its Contributions) on an "AS IS" BASIS,
154
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
155
+ implied, including, without limitation, any warranties or conditions
156
+ of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A
157
+ PARTICULAR PURPOSE. You are solely responsible for determining the
158
+ appropriateness of using or redistributing the Work and assume any
159
+ risks associated with Your exercise of permissions under this License.
160
+ 
161
+ 8. Limitation of Liability. In no event and under no legal theory,
162
+ whether in tort (including negligence), contract, or otherwise,
163
+ unless required by applicable law (such as deliberate and grossly
164
+ negligent acts) or agreed to in writing, shall any Contributor be
165
+ liable to You for damages, including any direct, indirect, special,
166
+ incidental, or consequential damages of any character arising as a
167
+ result of this License or out of the use or inability to use the
168
+ Work (including but not limited to damages for loss of goodwill,
169
+ work stoppage, computer failure or malfunction, or any and all
170
+ other commercial damages or losses), even if such Contributor
171
+ has been advised of the possibility of such damages.
172
+ 
173
+ 9. Accepting Warranty or Additional Liability. While redistributing
174
+ the Work or Derivative Works thereof, You may choose to offer,
175
+ and charge a fee for, acceptance of support, warranty, indemnity,
176
+ or other liability obligations and/or rights consistent with this
177
+ License. However, in accepting such obligations, You may act only
178
+ on Your own behalf and on Your sole responsibility, not on behalf
179
+ of any other Contributor, and only if You agree to indemnify,
180
+ defend, and hold each Contributor harmless for any liability
181
+ incurred by, or claims asserted against, such Contributor by reason
182
+ of your accepting any such warranty or additional liability.
183
+ 
184
+ END OF TERMS AND CONDITIONS
185
+ 
186
+ APPENDIX: How to apply the Apache License to your work.
187
+ 
188
+ To apply the Apache License to your work, attach the following
189
+ boilerplate notice, with the fields enclosed by brackets "[]"
190
+ replaced with your own identifying information. (Don't include
191
+ the brackets!) The text should be enclosed in the appropriate
192
+ comment syntax for the file format. We also recommend that a
193
+ file or class name and description of purpose be included on the
194
+ same "printed page" as the copyright notice for easier
195
+ identification within third-party archives.
196
+ 
197
+ Copyright 2012 DotCloud Inc
198
+ 
199
+ Licensed under the Apache License, Version 2.0 (the "License");
200
+ you may not use this file except in compliance with the License.
201
+ You may obtain a copy of the License at
202
+ 
203
+ http://www.apache.org/licenses/LICENSE-2.0
204
+ 
205
+ Unless required by applicable law or agreed to in writing, software
206
+ distributed under the License is distributed on an "AS IS" BASIS,
207
+ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
208
+ See the License for the specific language governing permissions and
209
+ limitations under the License.
210
+ 
211
+ 
212
+Files: src/github.com/kr/pty/*
213
+Copyright: Copyright (c) 2011 Keith Rarick
214
+License: Expat
215
+ Copyright (c) 2011 Keith Rarick
216
+ 
217
+ Permission is hereby granted, free of charge, to any person
218
+ obtaining a copy of this software and associated
219
+ documentation files (the "Software"), to deal in the
220
+ Software without restriction, including without limitation
221
+ the rights to use, copy, modify, merge, publish, distribute,
222
+ sublicense, and/or sell copies of the Software, and to
223
+ permit persons to whom the Software is furnished to do so,
224
+ subject to the following conditions:
225
+ 
226
+ The above copyright notice and this permission notice shall
227
+ be included in all copies or substantial portions of the
228
+ Software.
229
+ 
230
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
231
+ KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
232
+ WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
233
+ PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
234
+ OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
235
+ OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
236
+ OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
237
+ SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
... ...
@@ -5,6 +5,6 @@ stop on starting rc RUNLEVEL=[016]
5 5
 respawn
6 6
 
7 7
 script
8
-    test -f /etc/default/locale && . /etc/default/locale || true
8
+    /usr/bin/test -f /etc/default/locale && . /etc/default/locale || true
9 9
     LANG=$LANG LC_ALL=$LANG /usr/bin/docker -d
10 10
 end script
11 11
new file mode 100644
... ...
@@ -0,0 +1,4 @@
0
+#!/bin/sh
1
+
2
+# Start docker
3
+/sbin/start docker
0 4
new file mode 100644
... ...
@@ -0,0 +1,4 @@
0
+#!/bin/sh
1
+
2
+# Stop docker
3
+/sbin/stop docker
0 4
new file mode 100644
... ...
@@ -0,0 +1,34 @@
0
+Maintainer duty
1
+===============
2
+
3
+Ubuntu allows developers to use their PPA (Personal Package Archive)
4
+repository. This is very convenient for the users as they just need to add
5
+the PPA address, update their package database and use the apt-get tool.
6
+
7
+The official lxc-docker package is located on launchpad and can be accessed
8
+adding the following line to /etc/apt/sources.list ::
9
+
10
+  deb http://ppa.launchpad.net/dotcloud/lxc-docker/ubuntu precise main
11
+
12
+
13
+Realeasing a new package
14
+~~~~~~~~~~~~~~~~~~~~~~~~
15
+
16
+The most relevant information to update is the changelog file:
17
+Each new release should create a new first paragraph with new release version,
18
+changes, and the maintainer information.
19
+
20
+Assuming your PPA GPG signing key is on /media/usbdrive/docker.key, load it
21
+into the GPG_KEY environment variable with::
22
+
23
+  export GPG_KEY=`cat /media/usbdrive/docker.key`
24
+
25
+
26
+After this is done and you are ready to upload the package to the PPA, you have
27
+a couple of choices:
28
+
29
+* Follow README.debian to generate the actual source packages and upload them
30
+  to the PPA
31
+* Let vagrant do all the work for you::
32
+
33
+  ( cd docker/packaging/ubuntu; vagrant up )